/*
<root>
	<top>
		<a1/>
		<a2 attname="4">
			<b1 attname="5">
				<c1/>
				<c2/>
			</b1>
			<b2/>
			<base attname="9" xmlns:xpsql="http://www.xpsql.com">
				<d1/>
				<d2 attname="11">
					<e1/>
					<e2/>
				</d2>
				<d3/>
			</base>
			<b3 attval="15"/>
			<b4/>
		</a2>
		<a3/>
	</top>
</root>
*/

SELECT * from xml_node where docid=(select docid from xml_document where name='axis.xml') order by dewey;
/*
  id   | kind | docid | pathid |       dewey        | parent | child | next  | tagid |        value
-------+------+-------+--------+--------------------+--------+-------+-------+-------+----------------------
 68680 |   -1 |    31 |      0 | {-1,31}            |        |       |       |       |
 68679 |    0 |    31 |      0 | {0,31}             |        | 68681 |       |       |
 68681 |    1 |    31 |  68681 | {0,31,1}           |  68679 | 68682 |       |    31 |
 68682 |    1 |    31 |  68682 | {0,31,1,1}         |  68681 | 68683 |       |    32 |
 68683 |    1 |    31 |  68683 | {0,31,1,1,1}       |  68682 |       | 68684 |    33 |
 68684 |    1 |    31 |  68684 | {0,31,1,1,2}       |  68682 | 68686 | 68703 |    34 |
 68685 |    5 |    31 |  68685 | {0,31,1,1,2,0}     |  68684 |       |       |     4 | 4
 68686 |    1 |    31 |  68686 | {0,31,1,1,2,1}     |  68684 | 68688 | 68690 |    35 |
 68687 |    5 |    31 |  68687 | {0,31,1,1,2,1,0}   |  68686 |       |       |     4 | 5
 68688 |    1 |    31 |  68688 | {0,31,1,1,2,1,1}   |  68686 |       | 68689 |    36 |
 68689 |    1 |    31 |  68689 | {0,31,1,1,2,1,2}   |  68686 |       |       |    37 |
 68690 |    1 |    31 |  68690 | {0,31,1,1,2,2}     |  68684 |       | 68691 |    38 |
 68691 |    1 |    31 |  68691 | {0,31,1,1,2,3}     |  68684 | 68694 | 68700 |    39 |
 68692 |    5 |    31 |  68692 | {0,31,1,1,2,3,0}   |  68691 |       |       |     4 | 9
 68693 |    6 |    31 |        | {0,31,1,1,2,3,0}   |  68691 |       |       |     1 | http://www.xpsql.com
 68694 |    1 |    31 |  68694 | {0,31,1,1,2,3,1}   |  68691 |       | 68695 |    40 |
 68695 |    1 |    31 |  68695 | {0,31,1,1,2,3,2}   |  68691 | 68697 | 68699 |    41 |
 68696 |    5 |    31 |  68696 | {0,31,1,1,2,3,2,0} |  68695 |       |       |     4 | 11
 68697 |    1 |    31 |  68697 | {0,31,1,1,2,3,2,1} |  68695 |       | 68698 |    42 |
 68698 |    1 |    31 |  68698 | {0,31,1,1,2,3,2,2} |  68695 |       |       |    43 |
 68699 |    1 |    31 |  68699 | {0,31,1,1,2,3,3}   |  68691 |       |       |    44 |
 68700 |    1 |    31 |  68700 | {0,31,1,1,2,4}     |  68684 |       | 68702 |    45 |
 68701 |    5 |    31 |  68701 | {0,31,1,1,2,4,0}   |  68700 |       |       |     5 | 15
 68702 |    1 |    31 |  68702 | {0,31,1,1,2,5}     |  68684 |       |       |    46 |
 68703 |    1 |    31 |  68703 | {0,31,1,1,3}       |  68682 |       |       |    47 |
(25 rows)
*/


*/

select id,toxml(id) from xml_node where docid=(select docid from xml_document where name='axis.xml');

select id,toxml(id) from xpath_eval('//base');

select id,toxml(id) from xpath_eval('//base/child::node()',1);

select id,toxml(id) from xpath_eval('//base/descendant::node()');

select id,toxml(id) from xpath_eval('//base/parent::node()');

select toxml(id) from xpath_eval('//base/ancestor::node()');

select toxml(id) from xpath_eval('//base/following-sibling::node()');

select toxml(id) from xpath_eval('//base/preceding-sibling::node()');

select toxml(id) from xpath_eval('//base/following::node()');

select toxml(id) from xpath_eval('//base/preceding::node()');

select toxml(id) from xpath_eval('//base/self::node()');

select toxml(id) from xpath_eval('//base/descendant-or-self::node()');

select toxml(id) from xpath_eval('//base/ancestor-or-self::node()');

-- this evalution tends to cause same result for now.. need fix.
select toxml(id) from xpath_eval('//base/attribute::node()');
select toxml(id) from xpath_eval('//base/namespace::node()');